#!/usr/bin/perl
package MyFH;
require Tie::Handle; @ISA = qw( Tie::StdHandle );
sub CLOSE   { shift->SUPER::CLOSE(@_); kill 10, $$; } # SIGUSR1
sub DESTROY {                          kill 12, $$; } # SIGUSR2

package main;
use warnings;
use strict;
use Carp;

use Test::More tests => 12;
use Test::Exception;

use POWER::Utils;


my ($exitcode, $signal);
my @fh = ([], [fh => []], [fh => [\*STDIN, \*STDOUT, \*STDERR]]);
my ($USR1, $USR2) = (0, 0);
$SIG{USR1} = sub { $USR1++ };
$SIG{USR2} = sub { $USR2++ };
tie *STDIN, 'MyFH', '<', '/dev/null';
is_deeply([$USR1, $USR2], [0, 0],           'no SIGUSR* received after tie()');
for (@fh) {
    ($exitcode, $signal) = System({ cmd => ['bash -c "exit 100"'], @$_ });
    is_deeply([$exitcode, $signal], [100, 0],   '  no untie/close in System()');
}
close STDIN;
is_deeply([$USR1, $USR2], [1, 0],           '  SIGUSR1 received after close()');
tie *STDIN, 'MyFH', '<', '/dev/null';
for (@fh) {
    ($exitcode, $signal) = System({ cmd => ['bash -c "exit 100"'], @$_ });
    is_deeply([$exitcode, $signal], [100, 0],   '  no untie/close in System()');
}
untie *STDIN;
is_deeply([$USR1, $USR2], [1, 2],           '  SIGUSR2 received after untie()');
for (@fh) {
    ($exitcode, $signal) = System({ cmd => ['bash -c "exit 100"'], @$_ });
    is_deeply([$exitcode, $signal], [100, 0],   '  no untie/close in System()');
}

